#!/usr/bin/tclsh

# This script copies all the show wanted to an other destination and link
# back the file.  I use cifs and not NFS for mapping my NSLU@.

proc copyToNslu2 { source destination } {
puts "  $source ->"
puts "    $destination"
                                                                                                                             
if {![file exists [file dirname $destination]]} {
  puts "Exiting, destination directory doesn't exist!"
  return 1 "Destination directory doesn't exists!"
}
                                                                                                                             
if {[file type $source] != "file"} {
  return -code 1 -errorinfo "Source is not a file : type is [file type $source]"
}
                                                                                                                             
if {[file exists $destination]} {
  puts "Deleting file at destination... [file delete $destination]"
}
                                                                                                                             
#puts "file exists : [file exists $source]"
set sourceSize [file size $source]
#puts "file size   : $sourceSize"
#puts "Copying file...  Will take about [expr $sourceSize / 3 / 1024000] seconds..."
puts "      [expr $sourceSize / 3 /1024000 / 60] minutes"
set error [catch {file copy $source $destination} results]
if {$error} {
  return -code 1 -errorinfo $results
} else {
  #puts "Copy successful!"
  #puts "file exists at destination : [file exists $destination]"
  set destSize [file size $destination]
  if { $sourceSize != $destSize } {
    return -code 1 -errorinfo "Source size of $sourceSize is != of destination $destSize"
  }
  #puts "File size at destination   : [file size $destination]"
  puts "        Erasing file at source : [file delete $source]"
  #puts "Moving file at source(test): [file move $source $source.backup]"
  puts "          Linking new file : [file link -symbolic $source $destination]"
  return 0
}
}

#set fileToMove [lindex $argv 0]

# directory is the source directory of where the .nuv files are.
set directory /mnt/store 
# Destination directory where the files are going to be copied
set destdir /mnt/nslu2/store
puts "Getting Myth Title/Subtitle info..."
# Location of the shell script for grabiing the information from the
# database.
set mythPretty [exec /root/mythlink.sh]
foreach m [split $mythPretty \n] {
  set prettyArray([lindex $m 0]) [lindex $m 1]
}

set nuvs [glob [file join $directory *.nuv]] 
#set nuvs $fileToMove

foreach n $nuvs {
  set loop 1
  if {[file type $n] == "link"} { continue }
  while {$loop} {
    puts -nonewline "Move : $prettyArray([file tail $n]) (y/n)? "
    flush stdout
    gets stdin key
    set key [string tolower $key]
    if {$key == "y"} {
      lappend nuvList $n
      set loop 0
    } elseif {$key == "n"} {
      set loop 0
    }
  }
}

foreach n $nuvList {
  puts -nonewline "$n - File Type [file type $n] "
  if {[file type $n] != "link"} {
    set size1 [file size $n]
    after 5000
    set size2 [file size $n]
    if {$size1 != $size2} {
      puts "Skipping..."      
      continue
    }
    puts "Copying..."
    set source $n
    set destination [file join $destdir $prettyArray([file tail $n]).ts]
#    puts [file join $destdir $prettyArray([file tail $n]).ts]
    copyToNslu2 $source $destination
    #puts [exec tclsh /root/move.tcl $source $destination]
  } else {
    puts "Skipping..."  
  }
}
exit



set source [file join $directory]
set destination [file join $destdir]

puts "SOURCE                : $source"
puts "DESTINATION           : $destination"

if {![file exists $destdir]} {
  puts "Exiting, destination directory doesn't exist!"
  return 1 "Destination directory doesn't exists!"
}

if {[file type $source] != "file"} {
  return -code 1 -errorinfo "Source is not a file : type is [file type $source]"
}

if {[file exists $destination]} {
  puts "Deleting file at destination... [file delete $destination]"
}


puts "file exists : [file exists $source]"
set sourceSize [file size $source]
puts "file size   : $sourceSize"
#Gross estimation on of all long it's going to take for this file based
# on 3mbytes/sec transfer.
puts "Copying file...  Will take about [expr $sourceSize / 3 / 1024000 60] minutes..."
set error [catch {file copy $source $destination} results]
if {$error} {
  return -code 1 -errorinfo $results
} else {
  puts "Copy successful!"
  puts "file exists at destination : [file exists $destination]"
  set destSize [file size $destination] 
  if { $sourceSize != $destSize } {
    return -code 1 -errorinfo "Source size of $sourceSize is != of destination $destSize"
  }
  puts "File size at destination   : [file size $destination]"
  puts "Erasing file at source     : [file delete $source]"
  #puts "Moving file at source(test): [file move $source $source.backup]"
  puts "Linking new file to dest   : [file link -symbolic $source $destination]"
  return 0
}


